package autumn_2023.module.complex;

import adf.core.agent.communication.MessageManager;
import adf.core.agent.communication.standard.bundle.MessageUtil;
import adf.core.agent.communication.standard.bundle.information.MessageCivilian;
import adf.core.agent.develop.DevelopData;
import adf.core.agent.info.AgentInfo;
import adf.core.agent.info.ScenarioInfo;
import adf.core.agent.info.WorldInfo;
import adf.core.agent.module.ModuleManager;
import adf.core.agent.precompute.PrecomputeData;
import adf.core.component.communication.CommunicationMessage;
import adf.core.component.module.complex.FireTargetAllocator;
import autumn_2023.module.comm.infomation.MessageCost;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import rescuecore2.standard.entities.AmbulanceCentre;
import rescuecore2.standard.entities.AmbulanceTeam;
import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.worldmodel.EntityID;

public class AuctionFireTargetAllocator extends FireTargetAllocator{

    // 分散エージェントからの埋没市民のメッセージリスト
    private List<EntityID> receivedAgentCivilians = new ArrayList<>();
    private List<EntityID> finishreceivedCivilians = new ArrayList<>();

    // 分散エージェントからのコストのメッセージリスト
    private List<MessageCost> RescueCosts = new ArrayList<>();

    public AuctionFireTargetAllocator(AgentInfo ai, WorldInfo wi, ScenarioInfo si, ModuleManager moduleManager, DevelopData developData) 
    {
        super(ai, wi, si, moduleManager, developData);
    }


    @Override
  public FireTargetAllocator resume(PrecomputeData precomputeData) 
  {
    super.resume(precomputeData);

    return this;
  }


  @Override
  public FireTargetAllocator preparate() 
  {
    super.preparate();

    return this;
  }


  @Override
  public Map<EntityID, EntityID> getResult() 
  {
    return new HashMap<>();
  }


  @Override
  public FireTargetAllocator calc() 
  {
    return this;
  }


  @Override
  public FireTargetAllocator updateInfo(MessageManager messageManager) 
  {
    super.updateInfo(messageManager);

    // そのステップで受信した(前ステップで送信された)メッセージ一覧
    List<CommunicationMessage> messages = messageManager.getReceivedMessageList();
    for(CommunicationMessage mes : messages) 
    {
      // mesが市民の情報であれば
      if (mes instanceof MessageCivilian) 
      {
        MessageCivilian mesCiv = (MessageCivilian) mes;
        MessageUtil.reflectMessage(this.worldInfo, mesCiv);
        if (this.worldInfo.getEntity(mesCiv.getSenderID()) instanceof AmbulanceTeam 
            || this.worldInfo.getEntity(mesCiv.getSenderID()) instanceof FireBrigade) 
        {
          if(!receivedAgentCivilians.contains(mesCiv.getAgentID())
            || !finishreceivedCivilians.contains(mesCiv.getAgentID()))
          {
            receivedAgentCivilians.add(mesCiv.getAgentID());
          }
        }
      }
      // mesがコストの情報であれば
      if (mes instanceof MessageCost) {
        
      }
    }
    return this;
  }
}
